/***********************************************************************
 *
 * Copyright (C) 2003 Jan Fuchs
 *
 *              E-mail: fuky@seif.cz
 *                 Web: http://www.seif.cz
 *        Znakov sada: ISO-8859-2
 * Posledn modifikace: 23.11. 2003
 *
 *     Tento program je voln programov vybaven; mete jej it a
 * modifikovat podle ustanoven Obecn veejn licence GNU, vydvan
 * Free Software Foundation; a to bu verze 2 tto licence anebo
 * (podle vaeho uven) kterkoli pozdj verze.
 *
 *     Tento program je roziovn v nadji, e bude uiten, avak
 * BEZ JAKKOLI ZRUKY; neposkytuj se ani odvozen zruky PRODEJNOSTI
 * anebo VHODNOSTI PRO URIT EL.
 * Dal podrobnosti hledejte v Obecn veejn licenci GNU.
 *
 *    Kopii Obecn veejn licence GNU jste ml obdret spolu s tmto
 * programem; pokud se tak nestalo, napite o ni Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 ***********************************************************************/

#include "objekty.h"

void objekt_vytvor(void);
int objekt_sirka(int rotace, int tvar);
int objekt_vyska(int rotace, int tvar);

#ifdef SELF

int objekt[4][4][5][OBJ_POCET];

int main()
{
  int x;
  int y;
  int rotace;
  int tvar;

  objekt_vytvor();

  /* Vykresl vechny objekty na obrazovku, tak jak jsou vykresleny */
  /* v komentch a zobraz jejich ku, vku a slo tvaru      */
  for (tvar = 0; tvar < OBJ_POCET; ++tvar) {
    printf("tvar = %d\n", tvar);

    for (rotace = 0; rotace < 5; ++rotace) {
      printf("%dv%d ", objekt_sirka(rotace, tvar),
	     objekt_vyska(rotace, tvar));
    }

    printf("%s", "\n");

    for (y = 3; y >= 0; --y) {
      for (rotace = 0; rotace < 5; ++rotace) {
	for (x = 0; x < 4; ++x) {
	  if (objekt[x][y][rotace][tvar] == 1)
	    printf("%s", "O");
	  else
	  printf("%s", "-");
	}
	printf("%s", " ");
      }
      printf("%s", "\n");
    }
    printf("%s", "\n");
  }
  exit(0);
}

#else

extern int objekt[4][4][5][OBJ_POCET];

#endif

/* Popis vech objekt */
void objekt_vytvor(void) {
  int i;
  int j;
  int k;
  int l;

  /* Vechny poloky pole objekt[][][][] se nastav na 0 */
  for (i = 0; i < 4; ++i) {
    for (j = 0; j < 4; ++j) {
      for (k = 0; k < 5; ++k) {
	for (l = 0; l < OBJ_POCET; ++l) {
	  objekt[i][j][k][l] = 0;
	}
      }
    }
  }

  /*
   *  3 ---- ---- ---- ---- ----
   *  2 O--- ---- OO-- ---- OOO-
   *  1 O--- --O- -O-- OOO- OOO-
   *  0 OO-- OOO- -O-- O--- OOO-
   *
   *    0123
   */
  objekt[0][0][0][0] = 1;
  objekt[0][1][0][0] = 1;
  objekt[0][2][0][0] = 1;
  objekt[1][0][0][0] = 1;

  objekt[2][1][1][0] = 1;
  objekt[0][0][1][0] = 1;
  objekt[1][0][1][0] = 1;
  objekt[2][0][1][0] = 1;

  objekt[0][2][2][0] = 1;
  objekt[1][2][2][0] = 1;
  objekt[1][1][2][0] = 1;
  objekt[1][0][2][0] = 1;

  objekt[0][0][3][0] = 1;
  objekt[0][1][3][0] = 1;
  objekt[1][1][3][0] = 1;
  objekt[2][1][3][0] = 1;

  for (i = 0; i < 3; ++i) {
    for (j = 0; j < 3; ++j) {
      objekt[i][j][4][0] = 1;
    }
  }

  /*
   *  3 ---- ---- ---- ---- ----
   *  2 -O-- ---- -OO- ---- OOO-
   *  1 -O-- OOO- -O-- O--- OOO-
   *  0 OO-- --O- -O-- OOO- OOO-
   *
   *    0123
   */
  objekt[0][0][0][1] = 1;
  objekt[1][0][0][1] = 1;
  objekt[1][1][0][1] = 1;
  objekt[1][2][0][1] = 1;

  objekt[0][1][1][1] = 1;
  objekt[1][1][1][1] = 1;
  objekt[2][0][1][1] = 1;
  objekt[2][1][1][1] = 1;

  objekt[1][0][2][1] = 1;
  objekt[1][1][2][1] = 1;
  objekt[1][2][2][1] = 1;
  objekt[2][2][2][1] = 1;

  objekt[0][0][3][1] = 1;
  objekt[0][1][3][1] = 1;
  objekt[1][0][3][1] = 1;
  objekt[2][0][3][1] = 1;

  for (i = 0; i < 3; ++i) {
    for (j = 0; j < 3; ++j) {
      objekt[i][j][4][1] = 1;
    }
  }

  /*
   *  3 O--- ---- O--- ---- OOOO
   *  2 O--- ---- O--- ---- OOOO
   *  1 O--- ---- O--- ---- OOOO
   *  0 O--- OOOO O--- OOOO OOOO
   *
   *    0123
   */
  objekt[0][0][0][2] = 1;
  objekt[0][1][0][2] = 1;
  objekt[0][2][0][2] = 1;
  objekt[0][3][0][2] = 1;

  objekt[0][0][1][2] = 1;
  objekt[1][0][1][2] = 1;
  objekt[2][0][1][2] = 1;
  objekt[3][0][1][2] = 1;

  objekt[0][0][2][2] = 1;
  objekt[0][1][2][2] = 1;
  objekt[0][2][2][2] = 1;
  objekt[0][3][2][2] = 1;

  objekt[0][0][3][2] = 1;
  objekt[1][0][3][2] = 1;
  objekt[2][0][3][2] = 1;
  objekt[3][0][3][2] = 1;

  for (i = 0; i < 4; ++i) {
    for (j = 0; j < 4; ++j) {
      objekt[i][j][4][2] = 1;
    }
  }

  /*
   *  3 ---- ---- ---- ---- ----
   *  2 OOO- OOO- OOO- OOO- OOO-
   *  1 OOO- OOO- OOO- OOO- OOO-
   *  0 OOO- OOO- OOO- OOO- OOO-
   *
   *    0123
   */
  for (i = 0; i < 5; ++i) {
    for (j = 0; j < 3; ++j) {
      objekt[0][j][i][3] = 1;
      objekt[1][j][i][3] = 1;
      objekt[2][j][i][3] = 1;
    }
  }

  /*
   *  3 ---- ---- ---- ---- ----
   *  2 ---- ---- ---- ---- ----
   *  1 ---- ---- ---- ---- ----
   *  0 0--- 0--- 0--- 0--- 0---
   *
   *    0123
   */
  for (i = 0; i < 5; ++i) {
      objekt[0][0][i][4] = 1;
  }

  /*
   *  3 ---- ---- ---- ---- ----
   *  2 O--- ---- O--- ---- OOO-
   *  1 O--- ---- O--- ---- OOO-
   *  0 O--- OOO- O--- OOO- OOO-
   *
   *    0123
   */
  objekt[0][0][0][5] = 1;
  objekt[0][1][0][5] = 1;
  objekt[0][2][0][5] = 1;

  objekt[0][0][1][5] = 1;
  objekt[1][0][1][5] = 1;
  objekt[2][0][1][5] = 1;

  objekt[0][0][2][5] = 1;
  objekt[0][1][2][5] = 1;
  objekt[0][2][2][5] = 1;

  objekt[0][0][3][5] = 1;
  objekt[1][0][3][5] = 1;
  objekt[2][0][3][5] = 1;

  for (i = 0; i < 4; ++i) {
    for (j = 0; j < 4; ++j) {
      objekt[i][j][4][5] = 1;
    }
  }

  /*
   *  3 ---- ---- ---- ---- ----
   *  2 ---- ---- ---- ---- ----
   *  1 O--- -O-- OO-- O--- OO--
   *  0 OO-- OO-- O--- OO-- OO--
   *
   *    0123
   */
  objekt[0][0][0][6] = 1;
  objekt[0][1][0][6] = 1;
  objekt[1][0][0][6] = 1;

  objekt[0][0][1][6] = 1;
  objekt[1][0][1][6] = 1;
  objekt[1][1][1][6] = 1;

  objekt[0][0][2][6] = 1;
  objekt[0][1][2][6] = 1;
  objekt[1][1][2][6] = 1;

  objekt[0][0][3][6] = 1;
  objekt[0][1][3][6] = 1;
  objekt[1][0][3][6] = 1;

  for (i = 0; i < 2; ++i) {
    for (j = 0; j < 2; ++j) {
      objekt[i][j][4][6] = 1;
    }
  }
}

int objekt_sirka(int rotace, int tvar) {
  int i;
  int j;

  /*
   *  ----3
   *  ----2
   *  ----1
   *  ----0
   *  0123
   */
  for (i = 3; i >= 0; --i) {
    for (j = 0; j < 4; ++j) {
      if (objekt[i][j][rotace][tvar] == 1) {
	return i + 1;
      }
    }
  }

  return 0;
}

int objekt_vyska(int rotace, int tvar) {
  int i;
  int j;

  /*
   *   0123
   *  3----
   *  2----
   *  1----
   *  0----
   */
  for (j = 3; j >= 0; --j) {
    for (i = 0; i < 4; ++i) {
      if (objekt[i][j][rotace][tvar] == 1) {
	return j + 1;
      }
    }
  }

  return 0;
}
