/***********************************************************************
 *
 * Copyright (C) 2003 Jan Fuchs
 *
 *              E-mail: fuky@seif.cz
 *                 Web: http://www.seif.cz
 *        Znakov sada: ISO-8859-2
 * Posledn modifikace: 23.11. 2003
 *
 *     Tento program je voln programov vybaven; mete jej it a
 * modifikovat podle ustanoven Obecn veejn licence GNU, vydvan
 * Free Software Foundation; a to bu verze 2 tto licence anebo
 * (podle vaeho uven) kterkoli pozdj verze.
 *
 *     Tento program je roziovn v nadji, e bude uiten, avak
 * BEZ JAKKOLI ZRUKY; neposkytuj se ani odvozen zruky PRODEJNOSTI
 * anebo VHODNOSTI PRO URIT EL.
 * Dal podrobnosti hledejte v Obecn veejn licenci GNU.
 *
 *    Kopii Obecn veejn licence GNU jste ml obdret spolu s tmto
 * programem; pokud se tak nestalo, napite o ni Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 ***********************************************************************/

#include <unistd.h>
#include <stdlib.h>
#include <curses.h>

#include "hra.h"

#define MENU_POS_POL 4

static int polozka;
static int polozka_predchozi;

typedef struct menu {
  char nazev[21];
  int y;
} MENU;

#define MENU_NOVA_HRA   0
#define MENU_ULOZIT     1
#define MENU_NASTAVENI  2
#define MENU_O_PROGRAMU 3
#define MENU_KONEC      4

/* menu_hlavni[nzev][y souadnice] */
static MENU menu_hlavni[] = { { "Nov hra", 1 },
		       { "Uloit", 2 },
		       { "Nastaven", 3 },
		       { "O programu", 5 },
		       { "Konec", 6 },
};

void less(char soubor[10])
{
  int key;
  int i = 0;
  int j = 0;
  const int MAX = COLS - 5;
  char c;
  char radek[MAX + 1];
  FILE *fr;
  WINDOW *ram_window_ptr;
  WINDOW *o_programu_window_ptr;

  if ((fr = fopen(soubor, "r")) == NULL) {
    konec();
    printf("Soubor %s se nepodailo otevt.\n", soubor);
    exit(1);
  }

  ram_window_ptr = newwin(LINES, COLS, 0, 0);
  wborder(ram_window_ptr, ACS_VLINE, ACS_VLINE, ACS_HLINE,
	  ACS_HLINE, ACS_ULCORNER, ACS_URCORNER, ACS_LLCORNER,
	  ACS_LRCORNER);
  wrefresh(ram_window_ptr);

  o_programu_window_ptr = newwin(LINES - 2, COLS - 2, 1, 1);
  wattrset(o_programu_window_ptr, COLOR_PAIR(1) | A_BOLD);
  keypad(o_programu_window_ptr, TRUE);

  while ((c = fgetc(fr)) != EOF) {
    if ((c == '\n') || (i >= MAX) || ((i > (MAX - 15)) && (c == ' '))) {
      radek[i] = '\0';
      mvwprintw(o_programu_window_ptr, j, 1, "%s", radek);
      i = 0;
      ++j;
    }
    else {
      radek[i] = c;
      ++i;
    }

    if (j >= (LINES - 3)) {
      wattrset(o_programu_window_ptr, COLOR_PAIR(2));
      mvwprintw(o_programu_window_ptr, j, 1, "%s", " ENTER ");
      wattrset(o_programu_window_ptr, COLOR_PAIR(1) | A_BOLD);
      j = 0;

      key = wgetch(o_programu_window_ptr);
      while (key != ERR && key != LOCAL_SPACE_KEY &&
	     key != LOCAL_ENTER_KEY) {
	key = wgetch(o_programu_window_ptr);
      }
      wclear(o_programu_window_ptr);
    }
    wrefresh(o_programu_window_ptr);
  }

  if (fclose(fr) == EOF) {
    konec();
    printf("Soubor %s se nepodailo uzavt.\n", soubor);
    exit(1);
  }

  wattrset(o_programu_window_ptr, COLOR_PAIR(2));
  mvwprintw(o_programu_window_ptr, j, 1, "%s", " q ");
  wrefresh(o_programu_window_ptr);

  key = wgetch(o_programu_window_ptr);

  while (key != ERR && key != 'q' && key != LOCAL_ESCAPE_KEY) {
    key = wgetch(o_programu_window_ptr);
  }

  delwin(ram_window_ptr);
  delwin(o_programu_window_ptr);

  touchwin(leve_window_ptr);
  wrefresh(leve_window_ptr);
  touchwin(prave_window_ptr);
  wrefresh(prave_window_ptr);
  touchwin(menu_window_ptr);
  wrefresh(menu_window_ptr);
} /*** less() ***/

/* Zajiuje pohyb v menu */
static void menu_posun(void)
{
  /* Odvrazn poloku */
  wattrset(menu_window_ptr, COLOR_PAIR(1) | A_BOLD);
  mvwprintw(menu_window_ptr, menu_hlavni[polozka_predchozi].y, 2,
	    "  %s  ", menu_hlavni[polozka_predchozi].nazev);

  /* Zvrazn poloku */
  wattrset(menu_window_ptr, COLOR_PAIR(2));
  mvwprintw(menu_window_ptr, menu_hlavni[polozka].y, 2, "> %s <",
	    menu_hlavni[polozka].nazev);
} /* menu_posun() */

/* Spout vybranou akci z menu */
static void menu_vyber(void)
{
  switch (polozka) {
  case MENU_NOVA_HRA:
    nova_hra();
    touchwin(menu_window_ptr);
    wrefresh(menu_window_ptr);
    break;
  case MENU_ULOZIT:
    ulozit();
    break;
  case MENU_NASTAVENI:
    less("nastaveni\0");
    break;
  case MENU_O_PROGRAMU:
    less("o_programu\0");
    break;
  case MENU_KONEC:
    konec();
    exit(EXIT_SUCCESS);
    break;
  default:
    break;
  }
} /* menu_vyber() */

int main(int argc, char* argv[])
{
  int key;
  int i;

  polozka = 0;

  prodleva = 200000;
  znak[0] = 'O';
  znak[1] = '\0';

  if ((argc == 3) || (argc == 5)) {
    for (i = 1; i < argc; i += 2) {
      if ((strcmp(argv[i], "-t") == 0) && (atoi(argv[i + 1]) >= 1) &&
	  (atoi(argv[i + 1]) <= 10)) {
	prodleva = atoi(argv[i + 1]);
	prodleva *= 100000;
      }
      else if (strcmp(argv[i], "-o") == 0) {
	if (strcmp(argv[i + 1], "1") == 0)
	  znak[0] = (char)139;
	else if (strlen(argv[i + 1]) == 1)
	  strcpy(znak, argv[i + 1]);
      }
    }
  }

  initscr();

  HP_LINES = LINES;
  HP_COLS = COLS;

  kon_vel_obr();

  /* Otestuje jestli terminl podporuje barvy */
  if (!has_colors()) {
    endwin();
    fprintf(stderr, "CHYBA: Terminl nepodporuje barvy.\n");
    exit(1);
  }

  /* Sputn barevnho reimu */
  if (start_color() != OK) {
    endwin();
    fprintf(stderr, "CHYBA: Nepodailo se spustit barevn reim.\n");
    exit(1);
  }

  init_pair(1, COLOR_WHITE, COLOR_BLACK);
  init_pair(2, COLOR_BLACK, COLOR_WHITE);
  init_pair(3, COLOR_RED, COLOR_BLACK);
  init_pair(4, COLOR_YELLOW, COLOR_BLACK);

  cbreak();
  noecho();
  clear();

  leve_window_ptr = newwin(LINES, COLS - 21, 0, 0);
  wborder(leve_window_ptr, ACS_VLINE, ACS_VLINE, ACS_HLINE, ACS_HLINE,
	  ACS_ULCORNER, ACS_URCORNER, ACS_LLCORNER, ACS_LRCORNER);

  prave_window_ptr = newwin(LINES, 21, 0, COLS - 21);
  wborder(prave_window_ptr, ACS_VLINE, ACS_VLINE, ACS_HLINE, ACS_HLINE,
	  ACS_ULCORNER, ACS_URCORNER, ACS_LLCORNER, ACS_LRCORNER);

  mvwprintw(prave_window_ptr, 0, 4, " %s ", "TETRIS 1.0");

  menu_window_ptr = newwin(8, 18, LINES / 2 - 4, COLS / 2 - 19);
  wborder(menu_window_ptr, ACS_VLINE, ACS_VLINE, ACS_HLINE, ACS_HLINE,
	  ACS_ULCORNER, ACS_URCORNER, ACS_LLCORNER, ACS_LRCORNER);

  mvwprintw(menu_window_ptr, 0, 6, " %s ", "MENU");

  wattrset(menu_window_ptr, COLOR_PAIR(2));
  mvwprintw(menu_window_ptr, 1, 2, "> %s <", menu_hlavni[0].nazev);

  wattrset(menu_window_ptr, COLOR_PAIR(1) | A_BOLD);
  mvwprintw(menu_window_ptr, 2, 2, "  %s", menu_hlavni[1].nazev);
  mvwprintw(menu_window_ptr, 3, 2, "  %s", menu_hlavni[2].nazev);

  wattrset(menu_window_ptr, COLOR_PAIR(1));
  mvwhline(menu_window_ptr, 4, 2, ACS_HLINE, 14);

  wattrset(menu_window_ptr, COLOR_PAIR(1) | A_BOLD);
  mvwprintw(menu_window_ptr, 5, 2, "  %s", menu_hlavni[3].nazev);
  mvwprintw(menu_window_ptr, 6, 2, "  %s", menu_hlavni[4].nazev);

  wattrset(leve_window_ptr, COLOR_PAIR(1) | A_BOLD);
  wattrset(prave_window_ptr, COLOR_PAIR(1) | A_BOLD);

  wrefresh(leve_window_ptr);
  wrefresh(prave_window_ptr);
  wrefresh(menu_window_ptr);

  keypad(leve_window_ptr, TRUE);
  keypad(menu_window_ptr, TRUE);
  key = wgetch(menu_window_ptr);

  while (key != ERR && key != 'q' && key != LOCAL_ESCAPE_KEY) {
    polozka_predchozi = polozka;

    switch (key) {
    case KEY_END:
      polozka = MENU_POS_POL;
      break;
    case KEY_HOME:
      polozka = 0;
      break;
    case KEY_UP:
      --polozka;
      if (polozka < 0) polozka = MENU_POS_POL;
      break;
    case KEY_DOWN:
      ++polozka;
      if (polozka > MENU_POS_POL) polozka = 0;
      break;
    case LOCAL_ENTER_KEY:
      menu_vyber();
      break;
    default:
      break;
    } /* switch */

    kon_vel_obr();
    menu_posun();
    wrefresh(menu_window_ptr);
    key = wgetch(menu_window_ptr);
  } /* while */

  konec();

  exit(EXIT_SUCCESS);
} /* main() */
